MARTe2-core - User story #268

Type conversion engine
10.11.2015 09:18 - André Neto

Status: Closed Start date: 10.11.2015
Priority: Normal Due date:
Assignee: % Done: 0%
Category: Estimated time: 0.00 hour
Target version: 0.8 Spent time: 0.00 hour
Git branch (link): SVN commit

(link/?p=rev):
Git merge to develop
(link):
Description

Implement the TypeConversion engine based on the previous MARTe implementation and on the prototype available in the branch
Configuration_prototype.

This engine is responsible of the deserialisation of the types stored in the ConfigurationDatabase (scalars, vectors and matrices).
Each deserialised item is then type converted using the ScalarTypeConversion.

Note that this work does NOT include the ScalarTypeConversion work (see #269)

Source code files modified

e Source/Core/BareMetal/LOTypes/Vector.h
Source/Core/BareMetal/L0Types/Matrix.h
Source/Core/BareMetal/L4Configuration/AnyObject.h
Source/Core/BareMetal/L4Configuration/AnyObject.cpp
Source/Core/BareMetal/L4Configuration/TypeConversion.h
Source/Core/BareMetal/L4Configuration/TypeConversion.cpp
Source/Core/BareMetal/L4Configuration/ConfigurationDatabase.h
Source/Core/BareMetal/L4Configuration/ConfigurationDatabase.cpp
Source/Core/BareMetal/L4Configuration/FloatTolnteger.cpp
Source/Core/BareMetal/L4Configuration/IntegerToFloat.cpp
Source/Core/BareMetal/L4Configuration/StringToFloat.cpp
Source/Core/BareMetal/L4Configuration/StringTolnteger.cpp
Test/Core/BareMetal/LOTypes/VectorTest.h
Test/Core/BareMetal/L0Types/VectorTest.cpp
Test/Core/BareMetal/L0Types/MatrixTest.h
Test/Core/BareMetal/L0Types/MatrixTest.cpp
Test/Core/BareMetal/L4Configuration/AnyObjectTest.h
Test/Core/BareMetal/L4Configuration/AnyObjectTest.cpp
Test/Core/BareMetal/L4Configuration/TypeConversionTest.h
Test/Core/BareMetal/L4Configuration/TypeConversionTest.cpp
Test/Core/BareMetal/L4Configuration/ConfigurationDatabaseTest.h
Test/Core/BareMetal/L4Configuration/ConfigurationDatabaseTest.cpp
Test/GTest/AnyObjectGTest.cpp
Test/GTest/TypeConversionGTest.cpp
Test/GTest/ConfigurationDatabaseGTest.cpp

Architecture & design review
Date of the review: 10/11/2015
Person who did the review: André Neto

Version of architecture & design document: N/A. As per the original MARTe implementation. The interface was prototyped in a
dedicated branch and discussed in a technical meeting.

Result of review: N/A

List of non-conformities: N/A
https://vcis-redmine.f4e.europa.eu/issues/269

Code and documentation review
Date of the review: 25/11/2015 [on commit 8¢35328]
Person who did the review: lvan Herrero

Result of review: PASS

List of non-conformities: N/A

Comments:

The Vector and Matrix classes implementation use the standard new and delete operators.

On Vector and Matrix classes, the dataPointer member could be declared as a T* instead of a void*, so it will be unnecessary to
use reinterpret_cast<T*> on code.

On Vector and Matrix class, some functions could be non-members, like Product, Transpose, and so on.

The methods Determinant and Inverse of the Matrix class are declared as inline, but they are so big that it is useless.

The methods Determinant and Inverse of the Matrix class are defined with concrete types (Matrix<float32> and
Matrix<float64>), because they make sense only for floats, but then they are not generic implementations.

Unit test review

Date of the review: 25/11/2015 [on commit 8c35328]
Person who did the review: lvan Herrero

Result of coverage tests review: PASS

Result of functional tests review: PASS

Result of review: PASS

List of non-conformities: N/A

Associated revisions

Revision 24adff7a - 12.11.2015 18:54 - Giuseppe Ferro

#268 Work in Progress implementation and testing of type conversion

Revision d45779¢7 - 13.11.2015 18:10 - Giuseppe Ferro

#268 Added Type conversion tests.
Fixed code.

Revision 11105337 - 16.11.2015 18:11 - Giuseppe Ferro

Merge remote-tracking branch 'origin/develop' into #268_TypeConversion

Conflicts:
Test/GTest/Makefile.inc

Revision 8b3a6238 - 16.11.2015 18:33 - Giuseppe Ferro

Merge remote-tracking branch 'origin/#267_Configuration_Database_engine' into #268_TypeConversion

Revision 3b6ed531 - 17.11.2015 18:55 - Giuseppe Ferro

#268

- Lint and Documentation of StringTolnteger and StringToFloat done.
- Added tests to TypeConversion.

- Work in Progress Matrix and vector tests.

Revision cbd1db24 - 18.11.2015 09:28 - Giuseppe Ferro
#268 Fixed apporximation in float to int conversion 0.5-->1

posticipated saturation to 0 in string to unsigned number conversion.

Revision b30b02e7 - 18.11.2015 16:39 - Giuseppe Ferro
Merge remote-tracking branch 'origin/#267_Configuration_Database_engine
into #268_TypeConversion

Conflicts:
Source/Core/BareMetal/L4Configuration/TypeConversion.cpp

Revision c6¢27456 - 19.11.2015 13:36 - Giuseppe Ferro

#268 Added support for char arrays in type conversion.
Added new tests.

Divided functions in more files.

--Ready to be linted--

Revision 111fa8e7 - 19.11.2015 18:40 - Giuseppe Ferro

#268 Linting and documentation done.

Revision 11210097 - 20.11.2015 08:01 - Giuseppe Ferro
#268 Fixed a test.

Revision Ob14a3c2 - 20.11.2015 11:18 - André Neto
#267 Commit to synchronise with #268

Revision 6f2450b8 - 20.11.2015 11:43 - Giuseppe Ferro

#268 Fixed a bug in serialization of vector for CCStrings

Revision deee70ef - 20.11.2015 12:17 - André Neto
#267 synchronising with #268

Revision c160beaf - 23.11.2015 12:36 - Giuseppe Ferro
#268 Merged with #267 and fixed AnyObject.

Revision ee46a179 - 23.11.2015 18:47 - Giuseppe Ferro

#268 Added Tests to improve coverage.
Work in Progress on Matrix adding new feautures

Revision b257ac1a - 24.11.2015 12:41 - Giuseppe Ferro
#268 Added Matrix tests and checked coverage.

Revision 617{78d7 - 24.11.2015 13:46 - Giuseppe Ferro

Merge remote-tracking branch 'origin/#267_Configuration_Database_engine
into #268_TypeConversion

Conflicts:

MakeDefaults/Lint/marte_flint_files.Int
Source/Core/BareMetal/LO0Types/Matrix.h
Source/Core/BareMetal/L0Types/Vector.h
Source/Core/BareMetal/L4Configuration/AnyObject.cpp
Test/Core/BareMetal/L4Configuration/AnyObjectTest.cpp
Test/Core/BareMetal/L4Configuration/AnyObjectTest.h
Test/GTest/AnyObjectGTest.cpp

Revision 1bf7f{59 - 24.11.2015 14:53 - Giuseppe Ferro

Merge remote-tracking branch 'origin/develop' into #268_TypeConversion
Conflicts:

MakeDefaults/Lint/marte_flint_files.Int
Source/Core/BareMetal/L3Streams/String.cpp

Test/Core/BareMetal/L3Streams/StringTest.cpp
Test/GTest/Makefile.inc

Revision da053ad5 - 24.11.2015 17:15 - Giuseppe Ferro
#268 Added documentation to tests.

Revision 11204138 - 24.11.2015 17:17 - Giuseppe Ferro
#268 Moved Vector and Matrix tests to LOTypes

Revision 2138391a - 24.11.2015 17:21 - Giuseppe Ferro

#268 Improved documentation

Revision 3725d3b8 - 24.11.2015 17:36 - Giuseppe Ferro
#268 Added AnyObjectTest:: TestCleanUp().

Revision 8¢35328d - 25.11.2015 12:51 - Ivan Herrero

#268 - Minor corrections and improvements on documentation.

History

#1 - 10.11.2015 09:21 - André Neto

- Description updated

#2 - 10.11.2015 18:05 - Riccardo Vitelli
- Status changed from New to Code: Impl

- Target version set to 0.8

#3 - 11.11.2015 17:15 - Giuseppe Ferro

- Assignee set to Giuseppe Ferro

#4 - 24.11.2015 14:55 - Giuseppe Ferro
- Status changed from Code: Impl to Code: Rev

#5 - 24.11.2015 14:56 - Giuseppe Ferro
- Assignee deleted (Giuseppe Ferro)

code implementation done: 1bf7ff5
The branch includes user stories #267 and #269

#6 - 24.11.2015 14:58 - Giuseppe Ferro

- Description updated

#7 - 24.11.2015 17:51 - lvan Herrero
- Description updated

- Assignee set to Ivan Herrero

#8 - 25.11.2015 12:53 - Ivan Herrero

- Description updated

#9 - 25.11.2015 13:02 - Ivan Herrero

- Description updated

#10 - 25.11.2015 15:39 - lvan Herrero

- Assignee deleted (Ilvan Herrero)

Merged with develop on commit a15780e.

#11 - 25.11.2015 15:40 - lvan Herrero

Branch #268_TypeConversion deleted on https://vcis-gitlab.f4e.europa.eu/aneto/MARTe2.

#12 - 25.11.2015 15:47 - lvan Herrero

- Status changed from Code: Rev to Closed
